unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, ExtCtrls, Menus, StdCtrls, NMUDP, Db, Grids, DBGrids,
  DBTables, Mask, DBCtrls, Buttons, HCMngr, DECUtil, Sample, RSA, Komunikace,
  Psock, NMEcho;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    NMUDP1: TNMUDP;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    Memo2: TMemo;
    DataSource1: TDataSource;
    Table1: TTable;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit10: TDBEdit;
    Session1: TSession;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Table2: TTable;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    DBEdit13: TDBEdit;
    DBEdit14: TDBEdit;
    DBEdit15: TDBEdit;
    DBEdit16: TDBEdit;
    Label19: TLabel;
    Label20: TLabel;
    DBEdit17: TDBEdit;
    DBEdit18: TDBEdit;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn4: TBitBtn;
    HashManager1: THashManager;
    CipherManager1: TCipherManager;
    NMUDP2: TNMUDP;
    NMUDP3: TNMUDP;
    GroupBox7: TGroupBox;
    Memo3: TMemo;
    ClearMemos1: TMenuItem;
    Label21: TLabel;
    Label22: TLabel;
    DBEdit19: TDBEdit;
    DBEdit20: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    TabSheet4: TTabSheet;
    GroupBox8: TGroupBox;
    Label11: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label17: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    DataSource3: TDataSource;
    Table3: TTable;
    procedure Konec1Click(Sender: TObject);
    procedure TabSheet1Resize(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure NMUDP1DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String);
    procedure NMUDP2DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String);
    procedure NMUDP3DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String);
    procedure ClearMemos1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    procedure Memo3Change(Sender: TObject);
  private
    { Private declarations }
    PridanZakaznik:boolean;
    PridanObchodnik:boolean;
    SymetricKey,SymetricKey3,SymetricKey2,SymetricKey4,SymetricKey5:string;
    Cas,Datum:TDateTime;
    DelkaDat,Cena_Celkem:integer;
    DelkaDatCelkem:integer;
    NulovaniBZ,NulovaniBO,NulovaniPG:boolean;
    PrijataData,Hash_Obch,Hash_Zak:string;
    CU_Zak,CU_Obch,URL_Obch,URL_Banka_Zak,URL_Banka_Obch,URL_PG,URL_Zak:string;
    PK_Zak,PK_Banka_Zak,PK_Obch,PK_Banka_Obch,PK_PG:string;
    PRK_Banka_Zak,PRK_Banka_Obch,PRK_PG:string;
    procedure MemoHlavicka(memo:TMemo);
    procedure PrijmiZadostBZ(str:string;URL:string);
    procedure PrijmiZadostBO(str:string;URL:string);
    procedure PrijmiZadostPG(str:string;URL:string);
    procedure NulujPromenne();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Konec1Click(Sender: TObject);
begin
     Form1.Close;
end;

procedure TForm1.TabSheet1Resize(Sender: TObject);
begin
     Form1.GroupBox1.Height:=Form1.TabSheet1.Height div 3;
     Form1.GroupBox2.Height:=Form1.TabSheet1.Height div 3;
     Form1.GroupBox7.Height:=Form1.TabSheet1.Height div 3;
     Form1.GroupBox1.Width:=Form1.TabSheet1.Width;
     Form1.GroupBox2.Width:=Form1.TabSheet1.Width;
     Form1.GroupBox7.Width:=Form1.TabSheet1.Width;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
     PridanZakaznik:=False;
     PridanObchodnik:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
    time_start,time_end:TDateTime;
    VZ_klic,PZ_klic:BigNum;
    VO_klic,PO_klic:BigNum;
begin
  DelkaDat:=0;
  DelkaDatCelkem:=0;
  with Session1 do begin
    ConfigMode := cmSession;
    try
      AddStandardAlias('TEMPDIPLOM', ExtractFilePath(ParamStr(0)), 'PARADOX');
    finally
      ConfigMode := cmAll;
    end;
  end;
  Form1.Table1.Open;
  Form1.Table2.Open;
  Form1.Table3.Open;
  Form1.Edit1.Text:=LocalIP;
  Form1.Edit2.Text:=LocalIP;
  Form1.Edit3.Text:=LocalIP;

  MemoHlavicka(Form1.Memo1);
  Form1.Memo1.Lines.Add('Generuji veejn a privtn kl ...');
  time_start:=Time;
  PK_Banka_Zak:='++11IE:ElGyXEjzHNuGYv65fgHc76D7ZjcvZ3fE-09t-'+
                        '+rrNr5cmFPUZNLF7Qwn0D9G5G0mGHnwpV7noq70tCSXZg5p4k';
  PRK_Banka_Zak:='ElGyXEjzHNuGYv65fgHc76D7ZjcvZ3fE-09t-+rrNr5cmFPUZ'+
                         'NLF7Qwn0D9G5G0mGHnwpV7noq70tCSXZg5p4k:aSNeSJ9V07e'+
                         '0V1tfKq+aS+UX03xP1v4-SM0GQQa869o8icI2x3TpYg474-CPCprN-RpvLHqU3u1IdRGF3SJ4BU';
  time_end:=Time;
  Form1.Memo1.Lines.Add('   Privtn kl:');
  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PRK_Banka_Zak),length(PRK_Banka_Zak),fmtHEX));
  Form1.Memo1.Lines.Add('   Veejn kl:');
  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Zak),length(PK_Banka_Zak),fmtHEX));
  Form1.Memo1.Lines.Add('   Hotovo , doba generovn: '+TimeToStr(time_end-time_start));

  MemoHlavicka(Form1.Memo2);
  Form1.Memo2.Lines.Add('Generuji veejn a privtn kl ...');
  time_start:=Time;
  PK_Banka_Obch:='++11Ik:sgafXSmHb0lt0awKmeKHWOpKQTje3Rw-aV8vg5-yCc'+
                        '57TOXBvKmuS8yH-3+Jme1pFbWhPhacA5yqS4+DdCstw+';
  PRK_Banka_Obch:='sgafXSmHb0lt0awKmeKHWOpKQTje3Rw-aV8vg5-yCc57TOXB'+
                         'vKmuS8yH-3+Jme1pFbWhPhacA5yqS4+DdCstw+:onuvSxL1p'+
                         'NNWhPkQFUtp8XWqvwR631IgWDD9wqxjmR9N4OZaKzgVRvx+AjBI7jqgmFJNtNs+tHDWO1epQXgAKU';
  time_end:=Time;
  Form1.Memo2.Lines.Add('   Privtn kl:');
  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PRK_Banka_Obch),length(PRK_Banka_Obch),fmtHEX));
  Form1.Memo2.Lines.Add('   Veejn kl:');
  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Obch),length(PK_Banka_Obch),fmtHEX));
  Form1.Memo2.Lines.Add('   Hotovo , doba generovn: '+TimeToStr(time_end-time_start));

  MemoHlavicka(Form1.Memo3);
  Form1.Memo3.Lines.Add('Generuji veejn a privtn kl ...');
  time_start:=Time;
  PK_PG:='++11IE:7e9R7No3pKcljByChE4+u4VMoP39pLCq3ePH199tPNGshRku-'+
                        'f8pSHAnb2eTOS87Nk17DVhm8Mlt10EgQcjCWU';
  PRK_PG:='7e9R7No3pKcljByChE4+u4VMoP39pLCq3ePH199tPNGshRku-f8pSHA'+
                         'nb2eTOS87Nk17DVhm8Mlt10EgQcjCWU:C8uJ4OzNWJAYmF1mbqdx5dn'+
                         'WwWJnhjGFwcS7wE50e1jl31tZ35Hxi3wsq0d4I-jF-BKVteMLPk1bNZf1Irt66E';

  time_end:=Time;
  Form1.Memo3.Lines.Add('   Privtn kl:');
  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PRK_PG),length(PRK_PG),fmtHEX));
  Form1.Memo3.Lines.Add('   Veejn kl:');
  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
  Form1.Memo3.Lines.Add('   Hotovo , doba generovn: '+TimeToStr(time_end-time_start));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     Form1.Session1.DeleteAlias('TEMPDIPLOM');
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
     Form1.Table1.Edit;
     Form1.HashManager1.Algorithm:='Secure Hash Algorithm';
     Form1.HashManager1.CalcString(Form1.DBEdit1.Text+' '+Form1.DBEdit2.Text+' '+
                   Form1.DBEdit6.Text+' '+Form1.DBEdit9.Text);
     Form1.Table1.FieldValues['HASH']:=Form1.HashManager1.DigestString[fmtHEX];
     Form1.Table1.Post;
     PridanZakaznik:=False;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
     Form1.Table1.Edit;
     Form1.Table1.Insert;
     PridanZakaznik:=True;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
     if PridanZakaznik=True then
        Form1.Table1.Delete;
     PridanZakaznik:=False;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
     Form1.Table2.Edit;
     Form1.HashManager1.Algorithm:='Secure Hash Algorithm';
     Form1.HashManager1.CalcString(Form1.DBEdit11.Text+' '+Form1.DBEdit19.Text+' '+
                   Form1.DBEdit20.Text);
     Form1.Table2.FieldValues['HASH']:=Form1.HashManager1.DigestString[fmtHEX];
     Form1.Table2.Post;
     PridanObchodnik:=False;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
     if PridanObchodnik=True then
        Form1.Table2.Delete;
     PridanObchodnik:=False;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
     Form1.Table2.Edit;
     Form1.Table2.Insert;
     PridanObchodnik:=True;
end;

procedure TForm1.NMUDP1DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String);
var
  MyStream: TMemoryStream;
  TmpStr: String;
begin
     URL_PG:=Form1.Edit1.Text;
     URL_Banka_Zak:=Form1.Edit2.Text;
     URL_Banka_Obch:=Form1.Edit3.Text;

     if Form1.CheckBox1.Checked=True then begin
        MyStream := TMemoryStream.Create;
        try
           NMUDP1.ReadStream(MyStream);
           SetLength(TmpStr,NumberBytes);
           MyStream.Read(TmpStr[1],NumberBytes);
           MemoHlavicka(Memo1);
           Form1.Memo1.Lines.Add('Pijata data od '+FromIP+', Dlka: '+IntToStr(NumberBytes)+' bajt');
           PrijmiZadostBZ(TmpStr,FromIP);
        finally
           MyStream.Free;
        end;
     end;
end;

procedure TForm1.NMUDP2DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String);
var
  MyStream: TMemoryStream;
  TmpStr: String;
begin
     URL_PG:=Form1.Edit1.Text;
     URL_Banka_Zak:=Form1.Edit2.Text;
     URL_Banka_Obch:=Form1.Edit3.Text;

     if Form1.CheckBox2.Checked=True then begin
        MyStream := TMemoryStream.Create;
        try
           NMUDP2.ReadStream(MyStream);
           SetLength(TmpStr,NumberBytes);
           MyStream.Read(TmpStr[1],NumberBytes);
           MemoHlavicka(Memo2);
           Form1.Memo2.Lines.Add('Pijata data od '+FromIP+', Dlka: '+IntToStr(NumberBytes)+' bajt');
           PrijmiZadostBO(TmpStr,FromIP);
        finally
           MyStream.Free;
        end;
     end;
end;

procedure TForm1.NMUDP3DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String);
var
  MyStream: TMemoryStream;
  TmpStr: String;
begin
     URL_PG:=Form1.Edit1.Text;
     URL_Banka_Zak:=Form1.Edit2.Text;
     URL_Banka_Obch:=Form1.Edit3.Text;

     if Form1.CheckBox3.Checked=True then begin
        MyStream := TMemoryStream.Create;
        try
           NMUDP3.ReadStream(MyStream);
           SetLength(TmpStr,NumberBytes);
           MyStream.Read(TmpStr[1],NumberBytes);
           MemoHlavicka(Memo3);
           Form1.Memo3.Lines.Add('Pijata data od '+FromIP+', Dlka: '+IntToStr(NumberBytes)+' bajt '{+inttostr(strtoint('$'+Copy(Tmpstr,1,2)))});
           PrijmiZadostPG(TmpStr,FromIP);
        finally
           MyStream.Free;
        end;
     end;
end;

procedure TForm1.PrijmiZadostBZ(str:string;URL:string);
var id:integer;
    zprava,cislou:string;
begin
     id:=strtoint('$'+Copy(str,1,2));
     Form1.Memo1.Lines.Add('   ID zprvy: '+inttostr(id));
     case id of
          1: begin
                 URL_Zak:=URL;
                 PrijmiZpravu(str,SymetricKey,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,23,PK_Zak,SymetricKey);
                  end else begin
                     Form1.Memo1.Lines.Add('   dost o informace o stavu tu zkaznka.');
                     Form1.Memo1.Lines.Add('   HASH kd zkaznka:');
                     Form1.Memo1.Lines.Add('   '+zprava);
                     Form1.Table1.Filtered:=False;
                     Form1.Table1.Filter:='HASH='''+zprava+'''';
                     Form1.Table1.Filtered:=True;
                     if Form1.Table1.FindFirst=True then begin
                        zprava:=Form1.Table1.FieldByName('Konto').asString;
                        Form1.Memo1.Lines.Add('   Jmno zkaznka: '+Form1.Table1.FieldByName('Jmeno').asString+' '+
                               Form1.Table1.FieldByName('Prijmeni').asString);
                        Form1.Memo1.Lines.Add('   slo konta    : '+Form1.Table1.FieldByName('C_Konta').asString);
                        PosliZpravu(URL_Zak,Port_Zak,zprava,2,PK_Zak,SymetricKey);
                     end else begin
                        Form1.Memo1.Lines.Add('   Tento zkaznk NEEXISTUJE !!!');
                        zprava:='*** Chyba: Tento zkaznk NEEXISTUJE !!!';
                        PosliZpravu(URL_Zak,Port_Zak,zprava,23,PK_Zak,SymetricKey);
                        Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     end;
                     Form1.Table1.Filtered:=False;
                  end;
             end;
         75: begin
                  PrijmiZpravu(str,SymetricKey,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,24,PK_Zak,SymetricKey);
                  end else begin
                     Form1.Memo1.Lines.Add('   dost o URL platebn brny.');
                     PosliZpravu(URL_Zak,Port_Zak,Form1.Edit1.Text,76,PK_Zak,SymetricKey);
                  end;
             end;
         13: begin
                  PrijmiZpravu(str,SymetricKey,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,24,PK_Zak,SymetricKey);
                  end else begin
                     Form1.Memo1.Lines.Add('   dost o vpis provedench plateb.');
                     Form1.Table3.Filtered:=False;
                     Form1.Table3.Filter:='HASH='''+zprava+'''';
                     Form1.Table3.Filtered:=True;
                     if Form1.Table3.FindFirst=True then begin
                        zprava:='';
                        repeat
                              zprava:=zprava+'   '+FormatDateTime('dd.mm.yyyy',Form1.Table3.FieldByName('Datum').asDateTime)+'  '+
                                                   FormatDateTime('hh.nn.ss',Form1.Table3.FieldByName('Cas').asDateTime)+'  '+
                                                   Format('%12s  %15s',[Form1.Table3.FieldByName('Suma').asString+' K',
                                                                        Form1.Table3.FieldByName('C_Konta').asString])+#13+#10;
                        until not Form1.Table3.FindNext=True;
                     end;
                     Form1.Table3.Filtered:=False;
                     PosliZpravu(URL_Zak,Port_Zak,zprava,13,PK_Zak,SymetricKey);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end;
             end;
         99: begin
                  PrijmiVerejnyKlic(str,PK_Zak);
                  Form1.Memo1.Lines.Add('   Veejn kl zkaznka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Zak),length(PK_Zak),fmtHEX));
                  PosliVerejnyKlic(URL,Port_Zak,PK_Banka_Zak,98);
             end;
         89: begin
                  PrijmiSymetrickyKlic(str,PK_Banka_Zak,PRK_Banka_Zak,SymetricKey);
                  Form1.Memo1.Lines.Add('   Symetrick kl zkaznka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(SymetricKey),length(SymetricKey),fmtHEX));
             end;
         95: begin
                  PrijmiVerejnyKlic(str,PK_PG);
                  Form1.Memo1.Lines.Add('   Veejn kl platebn brny:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
                  PosliVerejnyKlic(URL_PG,Port_PG,PK_Banka_Zak,98);
             end;
         87: begin
                  PrijmiSymetrickyKlic(str,PK_Banka_Zak,PRK_Banka_Zak,SymetricKey4);
                  Form1.Memo1.Lines.Add('   Symetrick kl platebn brny:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(SymetricKey4),length(SymetricKey4),fmtHEX));
             end;
          5: begin
                  PrijmiZpravu(str,SymetricKey4,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL,Port_PG,zprava,23,PK_PG,SymetricKey4);
                  end else begin
                     Form1.Memo1.Lines.Add('   HASH kd zkaznka:');
                     Form1.Memo1.Lines.Add('   '+zprava);
                     Form1.Table1.Filtered:=False;
                     Form1.Table1.Filter:='HASH='''+zprava+'''';
                     Form1.Table1.Filtered:=True;
                     if Form1.Table1.FindFirst=True then begin
                        zprava:=Form1.Table1.FieldByName('C_Konta').asString;
                        CU_Zak:=zprava;
                        Form1.Memo1.Lines.Add('   Jmno zkaznka: '+Form1.Table1.FieldByName('Jmeno').asString+' '+
                                                  Form1.Table1.FieldByName('Prijmeni').asString);
                        Form1.Memo1.Lines.Add('   slo konta     : '+CU_Zak);
                        PosliZpravu(URL_PG,Port_PG,zprava,7,PK_PG,SymetricKey4);
                     end else begin
                        Form1.Memo1.Lines.Add('   Tento zkaznk NEEXISTUJE !!!');
                        zprava:='*** Chyba: Zkaznk NEEXISTUJE !!!';
                        PosliZpravu(URL_PG,Port_PG,zprava,23,PK_PG,SymetricKey4);
                        Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     end;
                     Form1.Table1.Filtered:=False;
                  end;
             end;
          8: begin
                  PrijmiZpravu(str,SymetricKey4,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_PG,Port_PG,zprava,23,PK_PG,SymetricKey4);
                  end else begin
                     Form1.Memo1.Lines.Add('   Pevod penz na et:');
                     Form1.Memo1.Lines.Add('   slo tu: '+CU_Zak);
                     Form1.Memo1.Lines.Add('   stka    : '+zprava+' K');

                     Form1.Table1.Filtered:=False;
                     Form1.Table1.Filter:='C_Konta='''+CU_Zak+'''';
                     Form1.Table1.Filtered:=True;
                     if Form1.Table1.FindFirst=True then begin
                        if Form1.Table1.FieldByName('Konto').asInteger>-strtoint(zprava) then begin
                           Form1.Table1.Edit;
                           Form1.Table1.FieldByName('Konto').asInteger:=Form1.Table1.FieldByName('Konto').asInteger+strtoint(zprava);
                           Form1.Table1.Post;
                           Form1.Table3.Edit;
                           Form1.Table3.Insert;
                           Cas:=Time;
                           Datum:=Date;
                           Form1.Table3.FieldByName('HASH').asString:=Hash_zak;
                           Form1.Table3.FieldByName('Datum').asString:=DateToStr(Datum);
                           Form1.Table3.FieldByName('Cas').asString:=TimeToStr(Cas);
                           Form1.Table3.FieldByName('Suma').asInteger:=-strtoint(zprava);
                           Form1.Table3.Post;
                        end else begin
                           Form1.Memo1.Lines.Add('   Tento zkaznk nem dostatenou hotovost na tu !!!');
                           zprava:='*** Chyba: Zkaznk nem dostatenou hotovost na tu !!!';
                           PosliZpravu(URL_PG,Port_PG,zprava,23,PK_PG,SymetricKey4);
                           Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                        end;
                     end;
                     Form1.Table1.Filtered:=False;

                  end;
             end;
          6: begin
                  PrijmiZpravu(str,SymetricKey4,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_PG,Port_PG,zprava,23,PK_PG,SymetricKey4);
                  end else begin
                     Form1.Memo1.Lines.Add('   slo konta obchodnka: '+zprava);

                     Form1.Table3.Filtered:=False;
                     Form1.Table3.Filter:='HASH='''+Hash_zak+''' and Datum='''+DateToStr(Datum)+''' and '+
                                          'Cas='''+TimeToStr(Cas)+'''';
                     Form1.Table3.Filtered:=True;
                     if Form1.Table3.FindFirst=True then begin
                        Form1.Table3.Edit;
                        Form1.Table3.FieldByName('C_Konta').asString:=zprava;
                        Form1.Table3.Post;
                     end;
                     Form1.Table3.Filtered:=False;
                  end;
             end;
         20: begin
                  PrijmiZpravu(str,SymetricKey4,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         21: begin
                  PrijmiZpravu(str,SymetricKey,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         25: begin
                  PrijmiZpravu(str,SymetricKey4,PK_Banka_Zak,PRK_Banka_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
     end;
end;

procedure TForm1.PrijmiZadostBO(str:string;URL:string);
var id:integer;
    zprava,cislou:string;
begin
     id:=strtoint('$'+Copy(str,1,2));
     Form1.Memo2.Lines.Add('   ID zprvy: '+inttostr(id));
     case id of
         96: begin
                  URL_Obch:=URL;
                  PrijmiVerejnyKlic(str,PK_Obch);
                  Form1.Memo2.Lines.Add('   Veejn kl obchodnka:');
                  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PK_Obch),length(PK_Obch),fmtHEX));
                  PosliVerejnyKlic(URL_Obch,Port_Obch,PK_Banka_Obch,97);
             end;
         88: begin
                  PrijmiSymetrickyKlic(str,PK_Banka_Obch,PRK_Banka_Obch,SymetricKey5);
                  Form1.Memo2.Lines.Add('   Symetrick kl obchodnka:');
                  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(SymetricKey5),length(SymetricKey5),fmtHEX));
             end;
         75: begin
                  PrijmiZpravu(str,SymetricKey5,PK_Banka_Obch,PRK_Banka_Obch,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo2.Lines.Add(zprava);
                     Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Obch,Port_Obch,zprava,24,PK_Obch,SymetricKey5);
                  end else begin
                     Form1.Memo2.Lines.Add('   dost o URL platebn brny.');
                     PosliZpravu(URL_Obch,Port_Obch,Form1.Edit1.Text,76,PK_Obch,SymetricKey5);
                  end;
             end;
         95: begin
                  PrijmiVerejnyKlic(str,PK_PG);
                  Form1.Memo2.Lines.Add('   Veejn kl platebn brny:');
                  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
                  PosliVerejnyKlic(URL_PG,Port_PG,PK_Banka_Obch,97);
             end;
         87: begin
                  PrijmiSymetrickyKlic(str,PK_Banka_Obch,PRK_Banka_Obch,SymetricKey2);
                  Form1.Memo2.Lines.Add('   Symetrick kl platebn brny:');
                  Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(SymetricKey2),length(SymetricKey2),fmtHEX));
             end;
          4: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Banka_Obch,PRK_Banka_Obch,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo2.Lines.Add(zprava);
                     Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_PG,Port_PG,zprava,24,PK_PG,SymetricKey2);
                  end else begin
                     Form1.Memo2.Lines.Add('   HASH kd obchodnka:');
                     Form1.Memo2.Lines.Add('   '+zprava);
                     Form1.Table2.Filtered:=False;
                     Form1.Table2.Filter:='HASH='''+zprava+'''';
                     Form1.Table2.Filtered:=True;
                     if Form1.Table2.FindFirst=True then begin
                        zprava:=Form1.Table2.FieldByName('C_Konta').asString;
                        CU_Obch:=zprava;
                        Form1.Memo2.Lines.Add('   Nzev obchodnka: '+Form1.Table2.FieldByName('Nazev').asString);
                        Form1.Memo2.Lines.Add('   slo konta     : '+Form1.Table2.FieldByName('C_Konta').asString);
                        Form1.Memo2.Lines.Add('   IO             : '+Form1.Table2.FieldByName('ICO').asString);
                        Form1.Memo2.Lines.Add('   DI             : '+Form1.Table2.FieldByName('DIC').asString);
                        PosliZpravu(URL_PG,Port_PG,zprava,6,PK_PG,SymetricKey2);
                     end else begin
                        Form1.Memo2.Lines.Add('   Tento obchodnk NEEXISTUJE !!!');
                        zprava:='*** Chyba: Obchodnk NEEXISTUJE !!!';
                        PosliZpravu(URL_PG,Port_PG,zprava,24,PK_PG,SymetricKey2);
                        Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
                     end;
                     Form1.Table2.Filtered:=False;
                  end;
             end;
          8: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Banka_Obch,PRK_Banka_Obch,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo2.Lines.Add(zprava);
                     Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_PG,Port_PG,zprava,24,PK_PG,SymetricKey2);
                  end else begin
                     Form1.Memo2.Lines.Add('   Pevod penz na et:');
                     Form1.Memo2.Lines.Add('   slo tu: '+CU_Obch);
                     Form1.Memo2.Lines.Add('   stka    : '+zprava+' K');
                     Form1.Table2.Filtered:=False;
                     Form1.Table2.Filter:='C_Konta='''+CU_Obch+'''';
                     Form1.Table2.Filtered:=True;
                     if Form1.Table2.FindFirst=True then begin
                        Form1.Table2.Edit;
                        Form1.Table2.FieldByName('Konto').asInteger:=Form1.Table2.FieldByName('Konto').asInteger+strtoint(zprava);
                        Form1.Table2.Post;
                     end;
                     Form1.Table2.Filtered:=False;
                  end;
             end;
         20: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Banka_Obch,PRK_Banka_Obch,zprava);
                  Form1.Memo2.Lines.Add(zprava);
                  Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
             end;
         25: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Banka_Obch,PRK_Banka_Obch,zprava);
                  Form1.Memo2.Lines.Add(zprava);
                  Form1.Memo2.Lines.Add('--- KONEC SPOJEN ---');
             end;
     end;
end;

procedure TForm1.PrijmiZadostPG(str:string;URL:string);
var id:integer;
    zprava:string;
begin
     id:=strtoint('$'+Copy(str,1,2));
     Form1.Memo3.Lines.Add('   ID zprvy: '+inttostr(id));
     case id of
         99: begin
                  URL_Zak:=URL;
                  PrijmiVerejnyKlic(str,PK_Zak);
                  Form1.Memo3.Lines.Add('   Veejn kl zkaznka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_Zak),length(PK_Zak),fmtHEX));
                  PosliVerejnyKlic(URL_Zak,Port_Zak,PK_PG,95);
             end;
         89: begin
                  PrijmiSymetrickyKlic(str,PK_PG,PRK_PG,SymetricKey);
                  Form1.Memo3.Lines.Add('   Symetrick kl zkaznka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(SymetricKey),length(SymetricKey),fmtHEX));
             end;
         96: begin
                  PrijmiVerejnyKlic(str,PK_Obch);
                  Form1.Memo3.Lines.Add('   Veejn kl obchodnka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_Obch),length(PK_Obch),fmtHEX));
                  URL_Obch:=URL;
                  PosliVerejnyKlic(URL_Obch,Port_Obch,PK_PG,95);
             end;
         88: begin
                  PrijmiSymetrickyKlic(str,PK_PG,PRK_PG,SymetricKey3);
                  Form1.Memo3.Lines.Add('   Symetrick kl obchodnka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(SymetricKey3),length(SymetricKey3),fmtHEX));
             end;
         79: begin
                  PrijmiDvojitouZpravu(str,PK_PG,PRK_PG,SymetricKey3,Hash_Zak,Hash_Obch);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo3.Lines.Add(zprava);
                     Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  end else begin
                     Form1.Memo3.Lines.Add('   dost o pevod penz z tu zkaznka na et obchodnka.');
                     Form1.Memo3.Lines.Add('   HASH kd obchodnka:');
                     Form1.Memo3.Lines.Add('   '+Hash_Obch);
                     Hash_Zak:=DekodujZpravu(Hash_Zak,SymetricKey,PK_PG,PRK_PG);
                     if copy(zprava,1,3)='***' then begin
                        Form1.Memo3.Lines.Add(zprava);
                        Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                        PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                     end else begin
                        Form1.Memo3.Lines.Add('   HASH kd zkaznka:');
                        Form1.Memo3.Lines.Add('   '+Hash_Zak);
                     end;
                  end;
             end;
          3: begin
                  PrijmiZpravu(str,SymetricKey3,PK_PG,PRK_PG,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo3.Lines.Add(zprava);
                     Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  end else begin
                     Cena_Celkem:=strtoint(zprava);
                     Form1.Memo3.Lines.Add('   stka k peveden: '+zprava+' K');
//                     PosliVerejnyKlic(URL_Banka_Obch,Port_Banka_Obch,PK_PG,95);
                     PosliVerejnyKlic(URL_Banka_Zak,Port_Banka_Zak,PK_PG,95);
                  end;
             end;
         97: begin
                  PrijmiVerejnyKlic(str,PK_Banka_Obch);
                  Form1.Memo3.Lines.Add('   Veejn kl banky obchodnka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Obch),length(PK_Banka_Obch),fmtHEX));
                  SymetricKey2:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey2,PK_Banka_Obch,URL_Banka_Obch,Port_Banka_Obch,87);
                  sleep(2000);
                  PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,Hash_Obch,4,PK_Banka_Obch,SymetricKey2);
             end;
          6: begin
                  PrijmiZpravu(str,SymetricKey2,PK_PG,PRK_PG,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo3.Lines.Add(zprava);
                     Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,zprava,25,PK_Banka_Obch,SymetricKey2);
                     PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,25,PK_Banka_Zak,SymetricKey4);
                     PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
                     PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  end else begin
                     Form1.Memo3.Lines.Add('   Penze budou pevedeny na et obchodnka: '+zprava);
                     PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,inttostr(Cena_Celkem),8,PK_Banka_Obch,SymetricKey2);
                     PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,6,PK_Banka_Zak,SymetricKey4);
//                     PosliVerejnyKlic(URL_Banka_Zak,Port_Banka_Zak,PK_PG,95);

                     PosliZpravu(URL_Obch,Port_Obch,inttostr(Cena_Celkem),9,PK_Obch,SymetricKey3);
                     PosliZpravu(URL_Zak,Port_Zak,inttostr(Cena_Celkem),10,PK_Zak,SymetricKey);
                     MemoHlavicka(Form1.Memo3);
                     zprava:='   Nkup byl spn proveden...';
                     Form1.Memo3.Lines.Add(zprava);
                     PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,zprava,20,PK_Banka_Obch,SymetricKey2);
                     PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,20,PK_Banka_Zak,SymetricKey4);
                     PosliZpravu(URL_Obch,Port_Obch,zprava,20,PK_Obch,SymetricKey3);
                     PosliZpravu(URL_Zak,Port_Zak,zprava,20,PK_Zak,SymetricKey);
                     Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                  end;
             end;
         98: begin
                  PrijmiVerejnyKlic(str,PK_Banka_Zak);
                  Form1.Memo3.Lines.Add('   Veejn kl banky zkaznka:');
                  Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Zak),length(PK_Banka_Zak),fmtHEX));
                  SymetricKey4:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey4,PK_Banka_Zak,URL_Banka_Zak,Port_Banka_Zak,87);
                  sleep(2000);
                  PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,Hash_Zak,5,PK_Banka_Zak,SymetricKey4);
             end;
          7: begin
                  PrijmiZpravu(str,SymetricKey4,PK_PG,PRK_PG,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo3.Lines.Add(zprava);
                     Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,25,PK_Banka_Zak,SymetricKey4);
                     PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,zprava,25,PK_Banka_Obch,SymetricKey2);
                     PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
                     PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  end else begin
                     Form1.Memo3.Lines.Add('   Penze budou pevedeny z tu zkaznka: '+zprava);
                     PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,inttostr(-Cena_Celkem),8,PK_Banka_Zak,SymetricKey4);
                     PosliVerejnyKlic(URL_Banka_Obch,Port_Banka_Obch,PK_PG,95);
                  end;
             end;
         21: begin
                  PrijmiZpravu(str,SymetricKey,PK_PG,PRK_PG,zprava);
                  Form1.Memo3.Lines.Add(zprava);
                  Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
//                  PosliZpravu(URL_Banka,Port_Banka_Obch,zprava,25,PK_Banka_Obch,SymetricKey2);
//                  PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
//                  PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
             end;
         22: begin
                  PrijmiZpravu(str,SymetricKey3,PK_PG,PRK_PG,zprava);
                  Form1.Memo3.Lines.Add(zprava);
                  Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
//                  PosliZpravu(URL_Banka,Port_Banka_Obch,zprava,25,PK_Banka_Obch,SymetricKey2);
                  PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
//                  PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
             end;
         23: begin
                  PrijmiZpravu(str,SymetricKey4,PK_PG,PRK_PG,zprava);
                  Form1.Memo3.Lines.Add(zprava);
                  Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                  PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,zprava,25,PK_Banka_Obch,SymetricKey2);
                  PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
             end;
         24: begin
                  PrijmiZpravu(str,SymetricKey2,PK_PG,PRK_PG,zprava);
                  Form1.Memo3.Lines.Add(zprava);
                  Form1.Memo3.Lines.Add('--- KONEC SPOJEN ---');
                  PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,25,PK_Banka_Zak,SymetricKey4);
                  PosliZpravu(URL_Obch,Port_Obch,zprava,25,PK_Obch,SymetricKey3);
                  PosliZpravu(URL_Zak,Port_Zak,zprava,25,PK_Zak,SymetricKey);
//                  NulujPromenne;
             end;
     end;
end;


procedure TForm1.MemoHlavicka(memo:TMemo);
begin
     memo.Lines.Add('');
     memo.Lines.Add(FormatDateTime('dd.mm.yyyy ',Date)+FormatDateTime('hh:nn:ss',Time));
end;

procedure TForm1.ClearMemos1Click(Sender: TObject);
begin
     Form1.Memo1.Clear;
     Form1.Memo2.Clear;
     Form1.Memo3.Clear;
     Form1.Memo1.Lines.Add('   Privtn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PRK_Banka_Zak),length(PRK_Banka_Zak),fmtHEX));
     Form1.Memo1.Lines.Add('   Veejn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Zak),length(PK_Banka_Zak),fmtHEX));
     Form1.Memo2.Lines.Add('   Privtn kl:');
     Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PRK_Banka_Obch),length(PRK_Banka_Obch),fmtHEX));
     Form1.Memo2.Lines.Add('   Veejn kl:');
     Form1.Memo2.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Obch),length(PK_Banka_Obch),fmtHEX));
     Form1.Memo3.Lines.Add('   Privtn kl:');
     Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PRK_PG),length(PRK_PG),fmtHEX));
     Form1.Memo3.Lines.Add('   Veejn kl:');
     Form1.Memo3.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     if Form1.CheckBox3.Checked=True then
        Form1.Memo3.Enabled:=True
     else
        Form1.Memo3.Enabled:=False;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     if Form1.CheckBox2.Checked=True then
        Form1.Memo2.Enabled:=True
     else
        Form1.Memo2.Enabled:=False;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     if Form1.CheckBox1.Checked=True then
        Form1.Memo1.Enabled:=True
     else
        Form1.Memo1.Enabled:=False;
end;

procedure TForm1.NulujPromenne;
begin
     if Form1.CheckBox3.Checked=False then
        NulovaniPG:=True;
     if Form1.CheckBox1.Checked=False then
        NulovaniBZ:=True;
     if Form1.CheckBox2.Checked=False then
        NulovaniBO:=True;

     if (NulovaniBO=True) and (NulovaniBZ=True) and (NulovaniPG=True) then begin
        SymetricKey:='';
        SymetricKey2:='';
        SymetricKey3:='';
        SymetricKey4:='';
        SymetricKey5:='';
//        PK_PG:='';
        PK_Zak:='';
        PK_Obch:='';
        Hash_zak:='';
        Hash_obch:='';
//        PK_Banka_Zak:='';
//        PK_Banka_OBch:='';
        NulovaniBZ:=False;
        NulovaniBO:=False;
        NulovaniPG:=False;
     end;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
     if copy(Form1.Memo1.Lines[Form1.Memo1.Lines.Count-1],1,3)='---' then
        NulovaniBZ:=True;
     NulujPromenne;
end;

procedure TForm1.Memo2Change(Sender: TObject);
begin
     if copy(Form1.Memo2.Lines[Form1.Memo2.Lines.Count-1],1,3)='---' then
        NulovaniBO:=True;
     NulujPromenne;
end;

procedure TForm1.Memo3Change(Sender: TObject);
begin
     if copy(Form1.Memo3.Lines[Form1.Memo3.Lines.Count-1],1,3)='---' then
        NulovaniPG:=True;
     NulujPromenne;
end;

end.
